#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySailingaTreasureCFG.h"
std::auto_ptr<M_ActivitySailingaTreasureCFG> M_ActivitySailingaTreasureCFG::msSingleton(nullptr);

int M_ActivitySailingaTreasureCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingaTreasureCFGData* M_ActivitySailingaTreasureCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySailingaTreasureCFGData>& M_ActivitySailingaTreasureCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingaTreasureCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySailingaTreasureCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingaTreasureCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mType = element->IntAttribute("Type");
		data.mResources = element->Attribute("Resources");
		{
			const char* AwardItemID = element->Attribute("AwardItemID");
			std::vector<std::string> vecAwardItemID;
			boost::split(vecAwardItemID, AwardItemID, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemID.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemID[i].c_str(), &temp))
				{
					data.mAwardItemID.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		{
			const char* PrivilegeName = element->Attribute("PrivilegeName");
			std::vector<std::string> vecPrivilegeName;
			boost::split(vecPrivilegeName, PrivilegeName, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecPrivilegeName.size(); i++)
			{
				data.mPrivilegeName.push_back(vecPrivilegeName[i]);
			}
		}
		{
			const char* PrivilegedResources = element->Attribute("PrivilegedResources");
			std::vector<std::string> vecPrivilegedResources;
			boost::split(vecPrivilegedResources, PrivilegedResources, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecPrivilegedResources.size(); i++)
			{
				data.mPrivilegedResources.push_back(vecPrivilegedResources[i]);
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySailingaTreasureCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaTreasureCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySailingaTreasureCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySailingaTreasureCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySailingaTreasureCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readString(L, "Resources", data.mResources);
		LuaCfgHelper::readVectorInt(L, "AwardItemID", data.mAwardItemID);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readVectorString(L, "PrivilegeName", data.mPrivilegeName);
		LuaCfgHelper::readVectorString(L, "PrivilegedResources", data.mPrivilegedResources);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySailingaTreasureCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaTreasureCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySailingaTreasureCFG* M_ActivitySailingaTreasureCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingaTreasureCFG());
	}
	return msSingleton.get();
}

void M_ActivitySailingaTreasureCFG::Release()
{
	msSingleton.reset(nullptr);
}
